#include <stdio.h>
#include "3dfx.h"
#define SST1INIT_VIDEO_ALLOCATE
#include "sst1init.h" /*contient les timings par defaut */


#define type 2

typedef struct {
  char* nom;
  sst1VideoTimingStruct timing ;
} mode_t ;


int
main (void )
{
  mode_t modes[] = {
	{"512x256@60", SST_VREZ_512X256_60 },
	{"512x384@60", SST_VREZ_512X384_60 },
	{"512x384@72", SST_VREZ_512X384_72 },
	{"512x384@75", SST_VREZ_512X384_75 },
	{"512x384@85", SST_VREZ_512X384_85 },
	{"512x384@120", SST_VREZ_512X384_120 },
	{"640x400@70", SST_VREZ_640X400_70 },
	{"640x400@75", SST_VREZ_640X400_75 },
	{"640x400@85", SST_VREZ_640X400_85 },
	{"640x400@120", SST_VREZ_640X400_120 },
	{"640x480@60", SST_VREZ_640X480_60 },
	{"640x480@75", SST_VREZ_640X480_75 },
	{"640x480@85", SST_VREZ_640X480_85 },
	{"640x480@120", SST_VREZ_640X480_120 },
	{"800x600@60", SST_VREZ_800X600_60 },
	{"800x600@75", SST_VREZ_800X600_75 },
	{"800x600@85", SST_VREZ_800X600_85 },
	{"856x480@60", SST_VREZ_856X480_60 },
	{"960x720@60", SST_VREZ_960X720_60 }
  };
  int i;
  sst1VideoTimingStruct t;
  for (i=0; i<18; i++ ) {
	t=modes[i].timing;
#if (type == 0)
	puts (modes[i].nom);
	printf ("pixclock16\t%d\n"
		"pixclock24\t%d\n"
		"left_margin\t%d\n"
		"right_margin\t%d\n"
		"upper_margin\t%d\n"
		"lower_margin\t%d\n"
		"hsync_len\t%d\n"
		"vsync_len\t%d\n"
		"tiles in X\t%d\n"
		"calculated tiles\t%d\n\n",
		 (int) (1e6/t.clkFreq16bpp),
		 (int) (1e6/t.clkFreq24bpp),
		t.hBackPorch,
		t.hSyncOff-t.hBackPorch-t.xDimension,
		t.vBackPorch,
		t.vSyncOff-t.vBackPorch-t.yDimension,
		t.hSyncOn,
		t.vSyncOn,
		t.tilesInX_Over2,
		((t.xDimension - 1) / 64) + 1
	);
#elif (type == 1)
	printf("{ \"%s\",\n",modes[i].nom);
	printf ("\t{ %d, %d, %d, %d, 0, 0, 16, 0,\n"
    		"\t{11, 5, 0}, {5, 6, 0}, {0, 5, 0}, {0, 0, 0},\n"
   		"\t0, 0, -1, -1, 0,\n"
		"\t%d, %d, %d, %d, %d, %d, %d,\n"
		"\t0, FB_VMODE_NONINTERLACED }\n},\n",
		t.xDimension, t.yDimension, t.xDimension, t.yDimension,
 		(int) (1e6/t.clkFreq16bpp),
		t.hBackPorch,
		t.hSyncOff-t.hBackPorch-t.xDimension,
		t.vBackPorch,
		t.vSyncOff-t.vBackPorch-t.yDimension,
		t.hSyncOn,
		t.vSyncOn
	);
#elif (type == 2)
	printf("mode \"sst_%s\"\n",modes[i].nom);
	printf("  geometry   %d %d   %d %d   16\n",
	       t.xDimension, t.yDimension, t.xDimension, t.yDimension);
	printf("  timings    %d   %d %d   %d %d   %d %d\nendmode\n\n",
	       (int) (1e6/t.clkFreq16bpp),
	       t.hBackPorch, t.hSyncOff-t.hBackPorch-t.xDimension,
	       t.vBackPorch, t.vSyncOff-t.vBackPorch-t.yDimension,
	       t.hSyncOn, t.vSyncOn);

#endif
  }
  return 1 ;
}
