#include <linux/fb.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <asm/ioctl.h>

#define IOCTL_NUM	_IOW('F',0xdc,u_int32_t)
#define IOCTL_NAME	"Fill frame buffer"

int main(int argc, char* argv[]) {
	char* fbPath;
	int f;
	u_int32_t size;
	struct stat sbf;
	char* e;

        if (argc < 3) {
                fprintf(stderr, "usage: %s fbdev size\n", argv[0]);
                return 1;
        }

	if (stat(argv[1], &sbf)) {	
	fprintf(stderr, "%s: are you sure that %s can be used to describe fbdev?\n", argv[0], argv[1]);
		return 1;
	}
	if (!S_ISCHR(sbf.st_mode)) {
		fprintf(stderr, "%s: %s must be character device\n", argv[0], argv[1]);
		return 1;
	}
	fbPath = argv[1];

	f = open(fbPath, O_RDWR);
	if (f < 0) {
		fprintf(stderr, "%s: Cannot open %s\n", argv[0], fbPath);
		return 1;
	}
	size = strtoul(argv[2], &e, 16);
	if (*e) {
		fprintf(stderr, "%s: size %s invalid \n", argv[0], argv[2]);
		return 1;
	}
	if (ioctl(f, IOCTL_NUM, &size)) {
		fprintf(stderr, "%s: ioctl %#x failed\n"
		"\tCheck that %s is a voodoo graphics fb,\n"
		"\tand that debug info is compiled in the driver.\n",
		 argv[0], IOCTL_NUM, fbPath);
		close(f);
		return 1;
	}
	close(f);
	printf("ioctl # %#x (%s) done.\n",IOCTL_NUM, IOCTL_NAME);
	return 0;
}


